# Git操作说明

下载并安装 [Git](https://git-scm.com/)


**git 常用操作名称**

1. pull 从服务器上面拉取代码
2. checkout 签出分支
3. add 将修改的文件添加到暂存区，等待commit
4. commit 提交代码到本地仓库
5. push 推送本地commit记录到服务器
6. stash 将当前修改未提交的文件存放到缓存区

## 项目初始化

```shell
# 创建readme文件
touch README.md
# git初始化
git init
# 添加文件到git版本控制
git add README.md
# 提交版本控制到本地，并添加注释信息
git commit -m "first commit"
# 添加远程服务器地址
git remote add origin http://121.40.122.81:3000/wukon/git-test.git
# 推送本地版本到服务器
git push -u origin master
```

**下载项目到本地**

在本地磁盘中找到一个文件夹（用于存放项目代码的，例如：Workspace），打开命令行窗口，输入 `git clone 远程仓库地址`，回车后等待文件下载完成即可

> 每次开发新功能时，需要创建新的分支，如果该功能和另一个新功能相关，则在同一分支进行开发

## vs code 版

1. 创建新分支

    从origin/master分支上创建新分支`dev_姓名缩写_日期`

    ![创建分支](./images/createBranch.gif)

1. 新建文件

   ![新建文件](./images/vsc_create.png)

1. 提交文件

    左侧切换到版本控制面板，在消息框内输入本次开发的内容，点击 Commit 即可提交本次开发的内容。
    ![提交文件1](./images/vsc_create2.png)
    如果本地改了多个文件，有些文件不需要提交，则通过更改文件后面的+号，选择性的添加文件到暂存区
    ![提交文件2](./images/vsc_create3.png)

1. 提交到远程服务器

本地开发完成后，填写提交消息，并提交到远程服务器

![提交并推送](./images/commitAndPush.gif)

1. 同步分支

    如果远程服务器已经存在该分支，则会出现同步按钮，点击后，编辑器会将远程分支先同步到本地再进行合并然后再推送到远程服务器

    ![同步分支](./images/vsc_git_sync.png)

    如果存在文件修改重复，则会出现文件冲突，需要选择要保留的修改内容，保存修改，然后在commit提交，再点击同步更改按钮，将合并后的结果推送到服务器

    ![vsc解决冲突文件](./images/vsc_git_confict.gif)

## IDEA 版

1. 创建新分支

    从origin/master分支上创建新分支`dev_姓名缩写_日期`

    ![创建分支](./images/idea_git_checkout.gif)

1. 提交并推送文件

    点击左上角的箭头，打开提交窗口，选择要提交的文件，填写本次修改内容，点击`commit`提交到本地版本库，点击 `commit and push` 提交到本地版本库并推送到服务器
    ![idea提交并推送](./images/idea_git_commitPush.gif)